This documentation is automatically generated by online-judge-tools/verification-helper
View the Project on GitHub maspypy/library
#define PROBLEM "https://judge.yosupo.jp/problem/aplusb" #include "my_template.hpp" #include "alg/monoid/min.hpp" #include "ds/segtree/dynamic_segtree_sparse.hpp" #include "random/base.hpp" void test() { using Mono = Monoid_Min<int>; int unit = Mono::unit(); FOR(100) { int N = RNG(1, 100); vc<int> A(N, unit); Dynamic_SegTree_Sparse<Mono, false> X(2 * N, 0, N); using np = typename decltype(X)::np; np root = nullptr; int Q = RNG(1, 1000); FOR(Q) { int t = RNG(0, 4); int L = RNG(0, N); int R = RNG(0, N); if (L > R) swap(L, R); ++R; if (t == 0) { int i = RNG(0, N); int x = RNG(1, 100); root = X.set(root, i, x); A[i] = x; } if (t == 1) { int i = RNG(0, N); int x = RNG(1, 100); root = X.multiply(root, i, x); chmin(A[i], x); } if (t == 2) { vc<int> B = {A.begin() + L, A.begin() + R}; assert(X.prod(root, L, R) == MIN(B)); } if (t == 3) { // max_right int LIM = RNG(1, 100); auto check = [&](auto e) -> bool { return e >= LIM; }; int naive = [&]() -> int { ll mi = unit; FOR(i, L, N) { chmin(mi, A[i]); if (mi < LIM) return i; } return N; }(); assert(naive == X.max_right(root, check, L)); } } } } void solve() { int a, b; cin >> a >> b; cout << a + b << "\n"; } signed main() { test(); solve(); return 0; }
#line 1 "test/1_mytest/dynamic_segtree_sparse.test.cpp" #define PROBLEM "https://judge.yosupo.jp/problem/aplusb" #line 1 "my_template.hpp" #if defined(LOCAL) #include <my_template_compiled.hpp> #else // https://codeforces.com/blog/entry/96344 #pragma GCC optimize("Ofast,unroll-loops") // いまの CF だとこれ入れると動かない? // #pragma GCC target("avx2,popcnt") #include <bits/stdc++.h> using namespace std; using ll = long long; using u8 = uint8_t; using u16 = uint16_t; using u32 = uint32_t; using u64 = uint64_t; using i128 = __int128; using u128 = unsigned __int128; using f128 = __float128; template <class T> constexpr T infty = 0; template <> constexpr int infty<int> = 1'010'000'000; template <> constexpr ll infty<ll> = 2'020'000'000'000'000'000; template <> constexpr u32 infty<u32> = infty<int>; template <> constexpr u64 infty<u64> = infty<ll>; template <> constexpr i128 infty<i128> = i128(infty<ll>) * 2'000'000'000'000'000'000; template <> constexpr double infty<double> = infty<ll>; template <> constexpr long double infty<long double> = infty<ll>; using pi = pair<ll, ll>; using vi = vector<ll>; template <class T> using vc = vector<T>; template <class T> using vvc = vector<vc<T>>; template <class T> using vvvc = vector<vvc<T>>; template <class T> using vvvvc = vector<vvvc<T>>; template <class T> using vvvvvc = vector<vvvvc<T>>; template <class T> using pq = priority_queue<T>; template <class T> using pqg = priority_queue<T, vector<T>, greater<T>>; #define vv(type, name, h, ...) vector<vector<type>> name(h, vector<type>(__VA_ARGS__)) #define vvv(type, name, h, w, ...) vector<vector<vector<type>>> name(h, vector<vector<type>>(w, vector<type>(__VA_ARGS__))) #define vvvv(type, name, a, b, c, ...) \ vector<vector<vector<vector<type>>>> name(a, vector<vector<vector<type>>>(b, vector<vector<type>>(c, vector<type>(__VA_ARGS__)))) // https://trap.jp/post/1224/ #define FOR1(a) for (ll _ = 0; _ < ll(a); ++_) #define FOR2(i, a) for (ll i = 0; i < ll(a); ++i) #define FOR3(i, a, b) for (ll i = a; i < ll(b); ++i) #define FOR4(i, a, b, c) for (ll i = a; i < ll(b); i += (c)) #define FOR1_R(a) for (ll i = (a)-1; i >= ll(0); --i) #define FOR2_R(i, a) for (ll i = (a)-1; i >= ll(0); --i) #define FOR3_R(i, a, b) for (ll i = (b)-1; i >= ll(a); --i) #define overload4(a, b, c, d, e, ...) e #define overload3(a, b, c, d, ...) d #define FOR(...) overload4(__VA_ARGS__, FOR4, FOR3, FOR2, FOR1)(__VA_ARGS__) #define FOR_R(...) overload3(__VA_ARGS__, FOR3_R, FOR2_R, FOR1_R)(__VA_ARGS__) #define all(x) x.begin(), x.end() #define len(x) ll(x.size()) #define elif else if #define eb emplace_back #define mp make_pair #define mt make_tuple #define fi first #define se second #define stoi stoll int popcnt(int x) { return __builtin_popcount(x); } int popcnt(u32 x) { return __builtin_popcount(x); } int popcnt(ll x) { return __builtin_popcountll(x); } int popcnt(u64 x) { return __builtin_popcountll(x); } int popcnt_sgn(int x) { return (__builtin_parity(unsigned(x)) & 1 ? -1 : 1); } int popcnt_sgn(u32 x) { return (__builtin_parity(x) & 1 ? -1 : 1); } int popcnt_sgn(ll x) { return (__builtin_parityll(x) & 1 ? -1 : 1); } int popcnt_sgn(u64 x) { return (__builtin_parityll(x) & 1 ? -1 : 1); } // (0, 1, 2, 3, 4) -> (-1, 0, 1, 1, 2) int topbit(int x) { return (x == 0 ? -1 : 31 - __builtin_clz(x)); } int topbit(u32 x) { return (x == 0 ? -1 : 31 - __builtin_clz(x)); } int topbit(ll x) { return (x == 0 ? -1 : 63 - __builtin_clzll(x)); } int topbit(u64 x) { return (x == 0 ? -1 : 63 - __builtin_clzll(x)); } // (0, 1, 2, 3, 4) -> (-1, 0, 1, 0, 2) int lowbit(int x) { return (x == 0 ? -1 : __builtin_ctz(x)); } int lowbit(u32 x) { return (x == 0 ? -1 : __builtin_ctz(x)); } int lowbit(ll x) { return (x == 0 ? -1 : __builtin_ctzll(x)); } int lowbit(u64 x) { return (x == 0 ? -1 : __builtin_ctzll(x)); } template <typename T> T kth_bit(int k) { return T(1) << k; } template <typename T> bool has_kth_bit(T x, int k) { return x >> k & 1; } template <typename UINT> struct all_bit { struct iter { UINT s; iter(UINT s) : s(s) {} int operator*() const { return lowbit(s); } iter &operator++() { s &= s - 1; return *this; } bool operator!=(const iter) const { return s != 0; } }; UINT s; all_bit(UINT s) : s(s) {} iter begin() const { return iter(s); } iter end() const { return iter(0); } }; template <typename UINT> struct all_subset { static_assert(is_unsigned<UINT>::value); struct iter { UINT s, t; bool ed; iter(UINT s) : s(s), t(s), ed(0) {} int operator*() const { return s ^ t; } iter &operator++() { (t == 0 ? ed = 1 : t = (t - 1) & s); return *this; } bool operator!=(const iter) const { return !ed; } }; UINT s; all_subset(UINT s) : s(s) {} iter begin() const { return iter(s); } iter end() const { return iter(0); } }; template <typename T> T floor(T a, T b) { return a / b - (a % b && (a ^ b) < 0); } template <typename T> T ceil(T x, T y) { return floor(x + y - 1, y); } template <typename T> T bmod(T x, T y) { return x - y * floor(x, y); } template <typename T> pair<T, T> divmod(T x, T y) { T q = floor(x, y); return {q, x - q * y}; } template <typename T, typename U> T SUM(const vector<U> &A) { T sm = 0; for (auto &&a: A) sm += a; return sm; } #define MIN(v) *min_element(all(v)) #define MAX(v) *max_element(all(v)) #define LB(c, x) distance((c).begin(), lower_bound(all(c), (x))) #define UB(c, x) distance((c).begin(), upper_bound(all(c), (x))) #define UNIQUE(x) sort(all(x)), x.erase(unique(all(x)), x.end()), x.shrink_to_fit() template <typename T> T POP(deque<T> &que) { T a = que.front(); que.pop_front(); return a; } template <typename T> T POP(pq<T> &que) { T a = que.top(); que.pop(); return a; } template <typename T> T POP(pqg<T> &que) { T a = que.top(); que.pop(); return a; } template <typename T> T POP(vc<T> &que) { T a = que.back(); que.pop_back(); return a; } template <typename F> ll binary_search(F check, ll ok, ll ng, bool check_ok = true) { if (check_ok) assert(check(ok)); while (abs(ok - ng) > 1) { auto x = (ng + ok) / 2; (check(x) ? ok : ng) = x; } return ok; } template <typename F> double binary_search_real(F check, double ok, double ng, int iter = 100) { FOR(iter) { double x = (ok + ng) / 2; (check(x) ? ok : ng) = x; } return (ok + ng) / 2; } template <class T, class S> inline bool chmax(T &a, const S &b) { return (a < b ? a = b, 1 : 0); } template <class T, class S> inline bool chmin(T &a, const S &b) { return (a > b ? a = b, 1 : 0); } // ? は -1 vc<int> s_to_vi(const string &S, char first_char) { vc<int> A(S.size()); FOR(i, S.size()) { A[i] = (S[i] != '?' ? S[i] - first_char : -1); } return A; } template <typename T, typename U> vector<T> cumsum(vector<U> &A, int off = 1) { int N = A.size(); vector<T> B(N + 1); FOR(i, N) { B[i + 1] = B[i] + A[i]; } if (off == 0) B.erase(B.begin()); return B; } // stable sort template <typename T> vector<int> argsort(const vector<T> &A) { vector<int> ids(len(A)); iota(all(ids), 0); sort(all(ids), [&](int i, int j) { return (A[i] == A[j] ? i < j : A[i] < A[j]); }); return ids; } // A[I[0]], A[I[1]], ... template <typename T> vc<T> rearrange(const vc<T> &A, const vc<int> &I) { vc<T> B(len(I)); FOR(i, len(I)) B[i] = A[I[i]]; return B; } template <typename T, typename... Vectors> void concat(vc<T> &first, const Vectors &... others) { vc<T> &res = first; (res.insert(res.end(), others.begin(), others.end()), ...); } #endif #line 2 "alg/monoid/min.hpp" template <typename E> struct Monoid_Min { using X = E; using value_type = X; static constexpr X op(const X &x, const X &y) noexcept { return min(x, y); } static constexpr X unit() { return infty<E>; } static constexpr bool commute = true; }; #line 2 "ds/segtree/dynamic_segtree_sparse.hpp" // 常にほとんどの要素が unit であることが保証されるような動的セグ木 // したがって、default_prod の類は持たせられず、acted monoid も一般には扱えない // 追加 N 回のときノード数 N 以下が保証される template <typename Monoid, bool PERSISTENT> struct Dynamic_SegTree_Sparse { using MX = Monoid; using X = typename MX::value_type; struct Node { ll idx; Node *l, *r; X prod, x; }; const int NODES; const ll L0, R0; Node *pool; int pid; using np = Node *; vc<np> FREE; Dynamic_SegTree_Sparse(int NODES, ll L0, ll R0) : NODES(NODES), L0(L0), R0(R0), pid(0) { pool = new Node[NODES]; } ~Dynamic_SegTree_Sparse() { delete[] pool; } // 木 dp のマージのときなどに使用すると MLE 回避できることがある // https://codeforces.com/problemset/problem/671/D void free_subtree(np c) { auto dfs = [&](auto &dfs, np c) -> void { if (c->l) dfs(dfs, c->l); if (c->r) dfs(dfs, c->r); FREE.eb(c); }; dfs(dfs, c); } np new_root() { return nullptr; } np new_node(ll idx, const X x) { if (!FREE.empty()) { np c = POP(FREE); c->idx = idx, c->l = c->r = nullptr; c->prod = c->x = x; return c; } assert(pid < NODES); pool[pid].idx = idx; pool[pid].l = pool[pid].r = nullptr; pool[pid].x = pool[pid].prod = x; return &(pool[pid++]); } X prod(np root, ll l, ll r) { assert(L0 <= l && l <= r && r <= R0); if (l == r) return MX::unit(); X x = MX::unit(); prod_rec(root, L0, R0, l, r, x); return x; } X prod_all(np root) { return prod(root, L0, R0); } np set(np root, ll i, const X &x) { assert(L0 <= i && i < R0); return set_rec(root, L0, R0, i, x); } np multiply(np root, ll i, const X &x) { assert(L0 <= i && i < R0); return multiply_rec(root, L0, R0, i, x); } template <typename F> ll max_right(np root, F check, ll L) { assert(L0 <= L && L <= R0 && check(MX::unit())); X x = MX::unit(); return max_right_rec(root, check, L0, R0, L, x); } template <typename F> ll min_left(np root, F check, ll R) { assert(L0 <= R && R <= R0 && check(MX::unit())); X x = MX::unit(); return min_left_rec(root, check, L0, R0, R, x); } void reset() { pid = 0; FREE.clear(); } vc<pair<ll, X>> get_all(np root) { vc<pair<ll, X>> res; auto dfs = [&](auto &dfs, np c) -> void { if (!c) return; dfs(dfs, c->l); res.eb(c->idx, c->x); dfs(dfs, c->r); }; dfs(dfs, root); return res; } X get(np root, ll idx) { auto dfs = [&](auto &dfs, np c) -> X { if (!c) return Monoid::unit(); if (idx == c->idx) return c->x; if (idx < (c->idx)) return dfs(dfs, c->l); return dfs(dfs, c->r); }; return dfs(dfs, root); } private: void update(np c) { c->prod = c->x; if (c->l) c->prod = MX::op(c->l->prod, c->prod); if (c->r) c->prod = MX::op(c->prod, c->r->prod); } np copy_node(np c) { if (!c || !PERSISTENT) return c; assert(pid < NODES); pool[pid].idx = c->idx; pool[pid].l = c->l; pool[pid].r = c->r; pool[pid].x = c->x; pool[pid].prod = c->prod; return &(pool[pid++]); } np set_rec(np c, ll l, ll r, ll i, X x) { if (!c) { c = new_node(i, x); return c; } c = copy_node(c); if (c->idx == i) { c->x = x; update(c); return c; } ll m = (l + r) / 2; if (i < m) { if (c->idx < i) swap(c->idx, i), swap(c->x, x); c->l = set_rec(c->l, l, m, i, x); } if (m <= i) { if (i < c->idx) swap(c->idx, i), swap(c->x, x); c->r = set_rec(c->r, m, r, i, x); } update(c); return c; } np multiply_rec(np c, ll l, ll r, ll i, X x) { if (!c) { c = new_node(i, x); return c; } c = copy_node(c); if (c->idx == i) { c->x = MX::op(c->x, x); update(c); return c; } ll m = (l + r) / 2; if (i < m) { if (c->idx < i) swap(c->idx, i), swap(c->x, x); c->l = multiply_rec(c->l, l, m, i, x); } if (m <= i) { if (i < c->idx) swap(c->idx, i), swap(c->x, x); c->r = multiply_rec(c->r, m, r, i, x); } update(c); return c; } void prod_rec(np c, ll l, ll r, ll ql, ll qr, X &x) { chmax(ql, l); chmin(qr, r); if (ql >= qr || !c) return; if (l == ql && r == qr) { x = MX::op(x, c->prod); return; } ll m = (l + r) / 2; prod_rec(c->l, l, m, ql, qr, x); if (ql <= (c->idx) && (c->idx) < qr) x = MX::op(x, c->x); prod_rec(c->r, m, r, ql, qr, x); } template <typename F> ll max_right_rec(np c, const F &check, ll l, ll r, ll ql, X &x) { if (!c || r <= ql) return R0; if (check(MX::op(x, c->prod))) { x = MX::op(x, c->prod); return R0; } ll m = (l + r) / 2; ll k = max_right_rec(c->l, check, l, m, ql, x); if (k != R0) return k; if (ql <= (c->idx)) { x = MX::op(x, c->x); if (!check(x)) return c->idx; } return max_right_rec(c->r, check, m, r, ql, x); } template <typename F> ll min_left_rec(np c, const F &check, ll l, ll r, ll qr, X &x) { if (!c || qr <= l) return L0; if (check(MX::op(c->prod, x))) { x = MX::op(c->prod, x); return L0; } ll m = (l + r) / 2; ll k = min_left_rec(c->r, check, m, r, qr, x); if (k != L0) return k; if (c->idx < qr) { x = MX::op(c->x, x); if (!check(x)) return c->idx + 1; } return min_left_rec(c->l, check, l, m, qr, x); } }; #line 2 "random/base.hpp" u64 RNG_64() { static u64 x_ = u64(chrono::duration_cast<chrono::nanoseconds>(chrono::high_resolution_clock::now().time_since_epoch()).count()) * 10150724397891781847ULL; x_ ^= x_ << 7; return x_ ^= x_ >> 9; } u64 RNG(u64 lim) { return RNG_64() % lim; } ll RNG(ll l, ll r) { return l + RNG_64() % (r - l); } #line 6 "test/1_mytest/dynamic_segtree_sparse.test.cpp" void test() { using Mono = Monoid_Min<int>; int unit = Mono::unit(); FOR(100) { int N = RNG(1, 100); vc<int> A(N, unit); Dynamic_SegTree_Sparse<Mono, false> X(2 * N, 0, N); using np = typename decltype(X)::np; np root = nullptr; int Q = RNG(1, 1000); FOR(Q) { int t = RNG(0, 4); int L = RNG(0, N); int R = RNG(0, N); if (L > R) swap(L, R); ++R; if (t == 0) { int i = RNG(0, N); int x = RNG(1, 100); root = X.set(root, i, x); A[i] = x; } if (t == 1) { int i = RNG(0, N); int x = RNG(1, 100); root = X.multiply(root, i, x); chmin(A[i], x); } if (t == 2) { vc<int> B = {A.begin() + L, A.begin() + R}; assert(X.prod(root, L, R) == MIN(B)); } if (t == 3) { // max_right int LIM = RNG(1, 100); auto check = [&](auto e) -> bool { return e >= LIM; }; int naive = [&]() -> int { ll mi = unit; FOR(i, L, N) { chmin(mi, A[i]); if (mi < LIM) return i; } return N; }(); assert(naive == X.max_right(root, check, L)); } } } } void solve() { int a, b; cin >> a >> b; cout << a + b << "\n"; } signed main() { test(); solve(); return 0; }